/* eslint-disable react/default-props-match-prop-types */
/* eslint-disable react/prop-types */
import React, { Children } from 'react';
import ButtonStyle from './buttonStyle';

export interface ButtonProps extends React.ButtonHTMLAttributes<HTMLElement> {
  titleName?: string;
  children?: React.ReactNode;
  invalid?: boolean;
  onClick?: (e: React.MouseEvent<HTMLButtonElement, MouseEvent>) => void;
  style?: React.CSSProperties;
  className?: string;
  iconSize?: number;
  iconColor?: string;
  solid?: any;
  hollow?: any;
  iconName?: string;
}

const Button: React.FC<ButtonProps> = props => {
  const { titleName, children, invalid, onClick, style, className, iconSize, iconColor, ...restProps } = props;
  return (
    <ButtonStyle
      solid={props.solid}
      hollow={props.hollow}
      invalid={invalid}
      onClick={e => {
        if (!props.invalid) {
          onClick && onClick(e);
        }
      }}
      style={style}
      {...restProps}
    >
      {props.iconName && (
        <span className={`iconfont ${props.iconName ? props.iconName : ''}`} style={{ fontSize: `${iconSize}px`, color: `${iconColor}` }} />
      )}
      {Children.toArray(children)}
      {titleName}
    </ButtonStyle>
  );
};
Button.defaultProps = {
  titleName: '',
  onClick: () => {},
};

export default Button;
